#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h> 
#include <netinet/if_ether.h> 
#include <netinet/in.h> 
#include <netinet/ip.h> 
#include <net/if.h> 
#include <sys/ioctl.h> 
#include <netpacket/packet.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include "eth.h"

int eth_init(unsigned char *mac);
void eth_close(void);
int eth_reset(void);
int eth_read(int count,char *buf);
int eth_write();
int eth_enableblock(void);
int eth_disableblock(void);
void get_macaddr(unsigned char *mac);

extern char eth[5];

extern char wbuf[9000];
extern int nwbuf;
extern char rbuf[9000];
extern int nrbuf;

unsigned char hw_source_addr[ETH_ALEN];
//unsigned char hw_dest_addr[ETH_ALEN] = {0x02, 0x00, 0x00, 0x00, 0x00, 0x01};
//unsigned char hw_dest_addr[ETH_ALEN] = {0x02, 0x00, 0x00, 0x00, 0x00, 0x02};
//unsigned char hw_dest_addr[ETH_ALEN] = {0xAA, 0xBB, 0xCC, 0xDD, 0xEE, 0xFF};

struct ethhdr ether_header; 

static int fd_schar;

#ifdef SIM_OUTPUT
  FILE *smfp;
#endif

int eth_init(unsigned char *mac)
{ 
#ifdef SIM_OUTPUT
  smfp=fopen("sim_out.hex","w");
#endif
  get_macaddr(mac);
  fd_schar = open("/dev/schar", O_RDWR);
        if (fd_schar == -1) {
                perror("open");
                return 1;
        }
  	eth_enableblock();   
}





int eth_reset(void)
{ 
  if(ioctl(fd_schar,SCHAR_RESET)==-1){
    printf(" error in SCHAR_RESET \n");
  }

  return 0;
}

int eth_read(int count,char *buf)
{
int err;
int size;
int loopcnt;
 
 loopcnt=0;
 size=0;
 GETMORE: 
        size=read(fd_schar,rbuf,nrbuf);
        if(size<0)return size;
        if(size<7){
           if(rbuf[0]==0x03&&loopcnt<100){usleep(100);loopcnt=loopcnt+1;goto GETMORE;}
        }
   return size;
}


int eth_write()
{
  char *msg;
  int msg_size;
  int nwritten;
  int i;
   //Creating the packet
     ether_header.h_proto = htons(nwbuf);
     //   ether_header.h_proto = htons(0xfff);

   msg_size = sizeof(ether_header) + nwbuf;
   if((msg = (unsigned char *)malloc(msg_size*sizeof(unsigned char))) == NULL){ 
           perror("rp_send: main(): malloc(): No memory available");
           exit(1);
   }
   memcpy(msg, &ether_header, sizeof(ether_header));
   memcpy(msg + sizeof(ether_header), wbuf, nwbuf);
#ifdef SIM_OUTPUT
   for(i=0;i<msg_size;i++)fprintf(smfp,"%02X",msg[i]&0xff);fprintf(smfp,"\n");
   fflush(smfp);
#endif
   //   for(i=0;i<msg_size;i++)printf("%02x",msg[i]&0xff);printf("\n");
   //   printf("Len : %4d\n",((msg[12]&0xff)<<8)|(msg[13]&0xff));
   nwritten = write(fd_schar, (const void *)msg, msg_size);
   free(msg);
   return nwritten; 

}


void eth_close(void)
{
#ifdef SIM_OUTPUT
  fclose(smfp);
#endif
  close(fd_schar);
}

int eth_enableblock(void)
{
  if(ioctl(fd_schar,SCHAR_BLOCKON)==-1){
    printf(" error in SCHAR_BLOCKON \n");
  }
  return 0;
}

int eth_disableblock(void)
{
  if(ioctl(fd_schar,SCHAR_BLOCKOFF)==-1){
    printf(" error in SCHAR_BLOCKOFF \n");
  }

  return 0;
}

void get_macaddr(unsigned char *hw_dest_addr)
{
FILE *fp;
int itmp;
char mesg[60];
 sprintf(mesg,"/sbin/ifconfig %c%c%c%c > macadd \0",eth[0],eth[1],eth[2],eth[3]);
 system(mesg); 
 fp=fopen("macadd","r");
 fscanf(fp,"eth%1d      Link encap:Ethernet  HWaddr %02x:%02x:%02x:%02x:%02x:%02x  \n",&itmp,&hw_source_addr[0],&hw_source_addr[1],&hw_source_addr[2],&hw_source_addr[3],&hw_source_addr[4],&hw_source_addr[5]);
 fclose(fp);
 printf("      Source: %02x-%02x-%02x-%02x-%02x-%02x\n",hw_source_addr[0]&0xff,hw_source_addr[1]&0xff,hw_source_addr[2]&0xff,hw_source_addr[3]&0xff,hw_source_addr[4]&0xff,hw_source_addr[5]&0xff); 
 printf(" Destination: %02x-%02x-%02x-%02x-%02x-%02x\n",hw_dest_addr[0]&0xff,hw_dest_addr[1]&0xff,hw_dest_addr[2]&0xff,hw_dest_addr[3]&0xff,hw_dest_addr[4]&0xff,hw_dest_addr[5]&0xff); 
   memcpy(ether_header.h_dest, hw_dest_addr, ETH_ALEN);
   memcpy(ether_header.h_source,hw_source_addr, ETH_ALEN);
}



/* void put_vmebuf(int ird,unsigned short int head, unsigned long int add,unsigned short int data)
{
  int i;
  unsigned short int *buf3;
  unsigned long int *buf4;
  char *bufw;
  char *buf2;
  printf(" enter put_vmebuf \n");
  bufw=bufvme+cntvme;
  buf2=bufvme+cntvme;
  buf3=(unsigned short int *)buf2;
  *buf3=head;
  cntvme=cntvme+2;
  buf2=buf2+2;
  buf4=(unsigned long int *)buf2;
  *buf4=add;
  cntvme=cntvme+4;
  buf2=buf2+4;
  buf3=(unsigned short int *)buf2;
  *buf3=data;
  cntvme=cntvme+2;
  buf2=buf2+2;
  if(ird==1)cntvme_rd=cntvme_rd+1;
  printf(" cntvme cntvme_rd %d %d \n",cntvme,cntvme_rd);
  for(i=0;i<6;i++)printf(" %02x ",bufw[7-i]&0xff);printf("\n");
} */





