#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "cnfg_defs.h"


#define MACSZ 14
#define PROTSZ 6
#define MAX_DATA_SZ 8994
#define DATA_INC 1
#define MAX_LINE  80
#define MAX_LINES 256


int main(void);

char eth[5]="eth1\0";

char wbuf[9000];
int nwbuf;
char rbuf[9000];
int nrbuf;

int main()
{
  static char *ffcmds[]  = {"ecc","no_ecc","vme","fifo","inj","no_inj",
			    "prst","mrst","st_mrk","rst_mrk",
			    "prg_off","rbk_off","rd_err_cnt","rst_err"};
  static char *gencmds[] = {"warn","no_warn","strt_pkt","no_strt_pkt",
			    "reload","leds","sysreset"};
  static char *cnfgcmds[]  = {"set_dflt","read_dflt","sav_cnum","rstr_cnum",
			    "rd_cnum_dir","rd_cnum_dcd","set_macs",
			    "rd_macs_dir","rd_macs_dcd","read_crs","wrt_crs",
                            "sc_bits","frc_sysrst","upd_lvls",
                            "wrt_ser_num","rd_ser_num"};
  static char *lucmds[] = {"help","load_cnfg","write_cnfg","prt_buf",
			    "cp_buf","quit"};
  static char *blank = "             ";

  int numff = 14;
  int numgen = 7;
  int numcnfg = 16;
  int numlu = 6;

  char *ptr1,*ptr2,*ptr3,*ptr4;
  char cmnd[25],cnfg_fn[128],c,ans[12];
  char *macaddrs[MAX_LINES],line[MAX_LINE],temp[4];
  char *dp;
  int i,j,l,n,lcnt,max,pg,cnt,lines;
  int cnfg_num,dflt_num,ser_num;
  unsigned int mask;
  unsigned int leds,full_off,mt_off;
  CNFG_ptr snd_cp,rcv_cp,scr_cp;
  enum MAC_ID mcid;
  enum CR_ID  crid;
  enum SET_CLR  sc;
  FILE *fp;
  unsigned char mac[6];

  fp=fopen("mac_addr.hex","r");
  fscanf(fp,"%02X-%02X-%02X-%02X-%02X-%02X",&mac[0],&mac[1],&mac[2],&mac[3],&mac[4],&mac[5]);
  fclose(fp);

  max=0;
  if(numff>max)max=numff;
  if(numgen>max)max=numgen;
  if(numcnfg>max)max=numcnfg;
  if(numlu>max)max=numlu;
  snd_cp = 0;
  rcv_cp = 0;
  scr_cp = 0;
  for(i=0;i<9000;i++)wbuf[i]=0;
  eth_init(mac);
  eth_reset();
  strcpy(cmnd,"help");
  while(strcmp(cmnd,"quit")!=0){
    if(strcmp(cmnd,"help")==0){
      printf("   FIFO          General       Config       Local Utils\n");
      printf("---------------------------------------------------------\n");
      for(l=0;l<max;l++){
        ptr1 = (l<numff)?ffcmds[l]:blank;
        ptr2 = (l<numgen)?gencmds[l]:blank;
        ptr3 = (l<numcnfg)?cnfgcmds[l]:blank;
        ptr4 = (l<numlu)?lucmds[l]:blank;
        printf("%-14s%-14s%-14s%-14s\n",ptr1,ptr2,ptr3,ptr4);
      }
    }
    else if(strcmp(cmnd,"ecc")==0){
      enable_ECC();
    }
    else if(strcmp(cmnd,"no_ecc")==0){
      disable_ECC();
    }
    else if(strcmp(cmnd,"vme")==0){
      set_VME_mode();
    }
    else if(strcmp(cmnd,"fifo")==0){
      set_ff_test_mode();
    }
    else if(strcmp(cmnd,"inj")==0){
      enable_inj_errs();
    }
    else if(strcmp(cmnd,"no_inj")==0){
      disable_inj_errs();
    }
    else if(strcmp(cmnd,"prst")==0){
      prst_ff();
    }
    else if(strcmp(cmnd,"mrst")==0){
      mrst_ff();
    }
    else if(strcmp(cmnd,"set_mrk")==0){
      set_mark();
    }
    else if(strcmp(cmnd,"rst_mrk")==0){
      rst_mark();
    }
    else if(strcmp(cmnd,"prg_off")==0){
      printf("enter Full  offset in hex (18 bits): ");
      scanf("%8x",&full_off);
      printf("enter Empty offset in hex (18 bits): ");
      scanf("%8x",&mt_off);
      prg_off(full_off,mt_off);
    }
    else if(strcmp(cmnd,"rbk_off")==0){
      rdbk_off();
    }
    else if(strcmp(cmnd,"rd_err_cnt")==0){
      rd_err_cnts();
    }
    else if(strcmp(cmnd,"rst_err")==0){
      rst_err_cnt();
    }
    else if(strcmp(cmnd,"warn")==0){
      enable_warn_on_shutdown();
    }
    else if(strcmp(cmnd,"no_warn")==0){
      disable_warn_on_shutdown();
    }
    else if(strcmp(cmnd,"strt_pkt")==0){
      snd_startup_pkt();
    }
    else if(strcmp(cmnd,"no_strt_pkt")==0){
      no_startup_pkt();
    }
    else if(strcmp(cmnd,"reload")==0){
      force_reload();
    }
    else if(strcmp(cmnd,"leds")==0){
      printf("enter 32 bit number in hex : ");
      scanf("%8x",&leds);
      ld_usr_reg(leds);
    }
    else if(strcmp(cmnd,"sysreset")==0){
      set_clr_bits(SET,VME,FRC_SYSRESET);
    }
    else if(strcmp(cmnd,"load_cnfg")==0){
      printf("Enter config filename: ");
      scanf("%s",cnfg_fn);
      scr_cp = load_cnfg(cnfg_fn);
      if(scr_cp== (CNFG_ptr)-1){
        printf("could not open file %s\n",cnfg_fn);
      }
      else {
        printf("Loaded Config:\n");
        print_cnfg(scr_cp);
        if(snd_cp == NULL){
          snd_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
        }
        cp_cnfg(snd_cp,scr_cp);
        free(scr_cp);
        scr_cp=0;
      }
    }
    else if(strcmp(cmnd,"write_cnfg")==0){
      if(rcv_cp == NULL){
        printf("No configuration in the receive buffer yet!\n");
      }
      else {
        printf("Enter config filename: ");
        scanf("%s",cnfg_fn);
        if(write_cnfg(rcv_cp,cnfg_fn)==-1){
          printf("could not open file %s\n",cnfg_fn);
        }
        else {
          printf("Receive buffer written to %s\n",cnfg_fn);
        }
      }
    }
    else if(strcmp(cmnd,"set_dflt")==0){
      printf("Enter default config num: ");
      scanf("%d",&dflt_num);
      set_cnfg_dflt(dflt_num);
    }
    else if(strcmp(cmnd,"read_dflt")==0){
      dflt_num = read_cnfg_dflt();
      printf("Default config num is : %d\n",dflt_num);
    }
    else if(strcmp(cmnd,"sav_cnum")==0){
      printf("Enter config num: ");
      scanf("%d",&cnfg_num);
      save_cnfg_num(cnfg_num);
    }
    else if(strcmp(cmnd,"rstr_cnum")==0){
      printf("Enter config num: ");
      scanf("%d",&cnfg_num);
      rstr_cnfg_num(cnfg_num);
    }
    else if(strcmp(cmnd,"rd_cnum_dir")==0){
      printf("Enter config num: ");
      scanf("%d",&cnfg_num);
      n=read_cnfg_num_dir(cnfg_num, &dp);
      if(n<0){
        printf("Error in controller.  Error type is %d\n",-n);
      }
      else {
        l=0;
        printf("   data    |    parity\n");
        printf("pg:ad  dt  |  pg:ad  dt\n");
        printf("-----------|------------\n");
        while(l<n){
          pg=dp[2*l];
          cnt=dp[2*l+1];
          l++;
          for(j=0;j<cnt;j+=6){
            for(i=j;i<j+3;i++){
              printf("%02X:%02X  %02X  |  ",pg&0xFF,dp[2*l+2*i]&0xFF,dp[2*l+2*i+1]&0xFF);
              printf("%02X:%02X  %02X\n",pg&0xFF,dp[2*l+2*i+6]&0xFF,dp[2*l+2*i+7]&0xFF);
            }
          }
          l+=cnt;
        }
      }
    }
    else if(strcmp(cmnd,"rd_cnum_dcd")==0){
      printf("Enter config num: ");
      scanf("%d",&cnfg_num);
      scr_cp = read_cnfg_num_dcd(cnfg_num);
      if(scr_cp<0){
        printf("Error in controller.  Error type is %d\n",-(int)scr_cp);
      }
      else {
        print_crs(scr_cp);
        if(rcv_cp == NULL){
          rcv_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
        }
        cp_crs(rcv_cp,scr_cp);
        free(scr_cp);
        scr_cp=0;
      }
    }
    else if(strcmp(cmnd,"set_macs")==0){
      if(snd_cp == NULL){
        printf("No configuration in the send buffer yet!\n");
        printf("Load configuration from file first.\n");
      }
      else {
        printf("DEVICE   -- %d\nMCAST1   -- %d\nMCAST2   -- %d\nMCAST3   -- %d\nDFLT_SRV -- %d\nALL_MACS -- %d\n",DEVICE,MCAST1,MCAST2,MCAST3,DFLT_SRV,ALL_MACS);
        printf("Choose MAC ID: ");
        scanf("%d",&mcid);
        if(mcid==DEVICE | mcid==ALL_MACS){
          l=0;
          macaddrs[l]=(char *)calloc(19,sizeof(char));
          for(i=0;i<6;i++){
            mac[i]=snd_cp->mac.device[i];
            (i<5) ? sprintf(temp,"%02X-",mac[i]) : sprintf(temp,"%02X\n",mac[i]);
            strcat(macaddrs[l],temp);
          }
          l++;
          set_macs(mcid,snd_cp);
          fp=fopen("mac_addr.hex","r");
          while(fgets(line,MAX_LINE,fp)!=NULL){
            macaddrs[l]=(char *)calloc(strlen(line)+1,sizeof(char));
            strcpy(macaddrs[l++],line);
          }
          lines=l;
          fclose(fp);
          fp=fopen("mac_addr.hex","w");
          for(l=0;l<lines;l++){
            if((strcmp(macaddrs[0],macaddrs[l])!=0) || l==0){
              fprintf(fp,"%s",macaddrs[l]);
	    }
          }
          fclose(fp);
          eth_close();
          usleep(1000);
          eth_init(mac);
        }
        else {
          set_macs(mcid,snd_cp);
        }
      }
    }
    else if(strcmp(cmnd,"rd_macs_dir")==0){
      n=read_macs_dir(&dp);
      if(n<0){
        printf("Error in controller.  Error type is %d\n",-n);
      }
      else {
        l=0;
        printf("   data    |    parity\n");
        printf("pg:ad  dt  |  pg:ad  dt\n");
        printf("-----------|------------\n");
        while(l<n){
          pg=dp[2*l];
          cnt=dp[2*l+1];
          l++;
          for(j=0;j<cnt;j+=6){
            for(i=j;i<j+3;i++){
              printf("%02X:%02X  %02X  |  ",pg&0xFF,dp[2*l+2*i]&0xFF,dp[2*l+2*i+1]&0xFF);
              printf("%02X:%02X  %02X\n",pg&0xFF,dp[2*l+2*i+6]&0xFF,dp[2*l+2*i+7]&0xFF);
            }
          }
          l+=cnt;
        }
      }
    }
    else if(strcmp(cmnd,"rd_macs_dcd")==0){
      scr_cp = read_macs_dcd();
      if(scr_cp<0){
        printf("Error in controller.  Error type is %d\n",-(int)scr_cp);
      }
      else {
        print_macs(scr_cp);
        if(rcv_cp == NULL){
          rcv_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
        }
        cp_macs(rcv_cp,scr_cp);
        free(scr_cp);
        scr_cp = 0;
      }
    }
    else if(strcmp(cmnd,"read_crs")==0){
      scr_cp = read_crs();
      print_crs(scr_cp);
      if(rcv_cp == NULL){
        rcv_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
      }
      cp_crs(rcv_cp,scr_cp);
      free(scr_cp);
      scr_cp = 0;
    }
    else if(strcmp(cmnd,"wrt_crs")==0){
      if(snd_cp == NULL){
        printf("No configuration in the send buffer yet!\n");
        printf("Load configuration from file first.\n");
      }
      else {
        printf("ETHER    -- %d\nEXTFIFO  -- %d\nRESET    -- %d\nVME      -- %d\nBTO      -- %d\nBGTO     -- %d\nALL_CRS  -- %d\n",ETHER,EXTFIFO,RESET,VME,BTO,BGTO,ALL_CRS);
        printf("Choose CR ID : ");
        scanf("%d",&crid);
        wrt_crs(crid,snd_cp);
      }
    }
    else if(strcmp(cmnd,"sc_bits")==0){
      printf("ETHER    -- %d\nEXTFIFO  -- %d\nRESET    -- %d\nVME      -- %d\nBTO      -- %d\nBGTO     -- %d\n",ETHER,EXTFIFO,RESET,VME,BTO,BGTO);
      printf("Choose CR ID : ");
      scanf("%d",&crid);
      printf("Set or Clear bit (s/c) : ");
      scanf("%*c%c",&c);
      sc=(c=='s')?SET:CLR;
      printf("Enter Mask in Hex : ");
      scanf("%8x",&mask);
      set_clr_bits(sc, crid, mask);
    }
    else if(strcmp(cmnd,"frc_sysrst")==0){
      sc = SET;
      crid = VME;
      mask = FRC_SYSRESET;
      set_clr_bits(sc, crid, mask);
    }
    else if(strcmp(cmnd,"upd_lvls")==0){
      sc = SET;
      crid = VME;
      mask = UPDATE_IH_LVLS;
      set_clr_bits(sc, crid, mask);
    }
    else if(strcmp(cmnd,"prt_buf")==0){
      printf("Receive or Send buffer (r/s): ");
      scanf("%*c%c",&c);
      if(c=='r'){
        if(rcv_cp == NULL){
          printf("Receive buffer is empty\n");
        }
        else {
          print_cnfg(rcv_cp);
        }
      }
      else if(c=='s'){
        if(snd_cp == NULL){
          printf("Send buffer is empty\n");
        }
        else {
          print_cnfg(snd_cp);
        }
      }
      else {
        printf("Must enter 'r' or 's'\n");
      }
    }
    else if(strcmp(cmnd,"cp_buf")==0){
      printf("Receive to Send buffer or\n");
      printf("Send to Receive buffer?\n");
      printf("(r2s/s2r): ");
      scanf("%s",ans);
      if(strcmp(ans,"r2s")==0){
        if(rcv_cp == NULL){
          printf("Receive buffer is empty\n");
        }
        else {
          if(snd_cp == NULL){
            snd_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
          }
          cp_cnfg(snd_cp,rcv_cp);
        }
      }
      else if(strcmp(ans,"s2r")==0){
        if(snd_cp == NULL){
          printf("Send buffer is empty\n");
        }
        else {
          if(rcv_cp == NULL){
            rcv_cp = (CNFG_ptr) malloc(sizeof(CNFG_t));
          }
          cp_cnfg(rcv_cp,snd_cp);
        }
      }
      else {
        printf("Must enter 'r2s' or 's2r'\n");
      }
    }
    else if(strcmp(cmnd,"wrt_ser_num")==0){
      ser_num = -1;
      while(ser_num <= 0 || ser_num >= 16777216){
        printf("Enter serial number: ");
        scanf("%d",&ser_num);
        if(ser_num>0 && ser_num<16777216){
          wrt_ser_num(ser_num);
        }
        else {
          printf("Number out of range!\n"); 
          printf("The serial number is a 24 bit number.\n"); 
          printf("It must be positive and < 16777216.\n");
        }
      }
    }
    else if(strcmp(cmnd,"rd_ser_num")==0){
      ser_num = rd_ser_num();
      printf("This is board: %d\n",ser_num);
    }
    else {
      printf("Unknown command, try again\n");
    }
    printf("Cmnd> ");
    scanf("%s",cmnd);
  }
  eth_close();
}
